# swagger_client

SwaggerClient - the Ruby gem for the TollGuru Calculator

TollGuru Calculator API

This SDK is automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: 2020-07-15T09:40:00Z
- Package version: 1.0.0
- Build package: io.swagger.codegen.languages.RubyClientCodegen
For more information, please visit [tollguru.com](tollguru.com)

## Installation

### Build a gem

To build the Ruby code into a gem:

```shell
gem build swagger_client.gemspec
```

Then either install the gem locally:

```shell
gem install ./swagger_client-1.0.0.gem
```
(for development, run `gem install --dev ./swagger_client-1.0.0.gem` to install the development dependencies)

or publish the gem to a gem hosting service, e.g. [RubyGems](https://rubygems.org/).

Finally add this to the Gemfile:

    gem 'swagger_client', '~> 1.0.0'

### Install from Git

If the Ruby gem is hosted at a git repository: https://github.com/GIT_USER_ID/GIT_REPO_ID, then add the following in the Gemfile:

    gem 'swagger_client', :git => 'https://github.com/GIT_USER_ID/GIT_REPO_ID.git'

### Include the Ruby code directly

Include the Ruby code directly using `-I` as follows:

```shell
ruby -Ilib script.rb
```

## Getting Started

Please follow the [installation](#installation) procedure and then run the following code:
```ruby
# Load the gem
require 'swagger_client'

api_instance = SwaggerClient::GPSTracestracksApi.new

opts = { 
  body: SwaggerClient::Body1.new # Body1 | 
}

begin
  #Download Async Results
  result = api_instance.route_download_post(opts)
  p result
rescue SwaggerClient::ApiError => e
  puts "Exception when calling GPSTracestracksApi->route_download_post: #{e}"
end

```

## Documentation for API Endpoints

All URIs are relative to *https://dev.tollguru.com*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*SwaggerClient::GPSTracestracksApi* | [**route_download_post**](docs/GPSTracestracksApi.md#route_download_post) | **POST** /route/download | Download Async Results
*SwaggerClient::GPSTracestracksApi* | [**route_upload_post**](docs/GPSTracestracksApi.md#route_upload_post) | **POST** /route/upload | Request
*SwaggerClient::OriginAndDestinationPairApi* | [**gmaps_post**](docs/OriginAndDestinationPairApi.md#gmaps_post) | **POST** /gmaps | Google Maps Routes
*SwaggerClient::OriginAndDestinationPairApi* | [**here_post**](docs/OriginAndDestinationPairApi.md#here_post) | **POST** /here | HERE Maps Routes
*SwaggerClient::RoutePolylineApi* | [**route_post**](docs/RoutePolylineApi.md#route_post) | **POST** /route | Route polyline (from HERE/ Google map)


## Documentation for Models

 - [SwaggerClient::Address](docs/Address.md)
 - [SwaggerClient::AsyncResponse](docs/AsyncResponse.md)
 - [SwaggerClient::Body](docs/Body.md)
 - [SwaggerClient::Body1](docs/Body1.md)
 - [SwaggerClient::Cost](docs/Cost.md)
 - [SwaggerClient::DateTime](docs/DateTime.md)
 - [SwaggerClient::Direction](docs/Direction.md)
 - [SwaggerClient::DirectionPosition](docs/DirectionPosition.md)
 - [SwaggerClient::Driver](docs/Driver.md)
 - [SwaggerClient::FuelEfficiency](docs/FuelEfficiency.md)
 - [SwaggerClient::GeoCordinates](docs/GeoCordinates.md)
 - [SwaggerClient::GmapRequestBody](docs/GmapRequestBody.md)
 - [SwaggerClient::GmapResponse](docs/GmapResponse.md)
 - [SwaggerClient::GmapResponseSummary](docs/GmapResponseSummary.md)
 - [SwaggerClient::GmapResponseSummaryFuelPrice](docs/GmapResponseSummaryFuelPrice.md)
 - [SwaggerClient::GmapRouteResponse](docs/GmapRouteResponse.md)
 - [SwaggerClient::GmapRouteResponseSummary](docs/GmapRouteResponseSummary.md)
 - [SwaggerClient::GmapRouteResponseSummaryDiffs](docs/GmapRouteResponseSummaryDiffs.md)
 - [SwaggerClient::GmapRouteResponseSummaryDistance](docs/GmapRouteResponseSummaryDistance.md)
 - [SwaggerClient::GmapRouteResponseSummaryDuration](docs/GmapRouteResponseSummaryDuration.md)
 - [SwaggerClient::HereRequestBody](docs/HereRequestBody.md)
 - [SwaggerClient::HereResponse](docs/HereResponse.md)
 - [SwaggerClient::HosData](docs/HosData.md)
 - [SwaggerClient::HosDataDistance](docs/HosDataDistance.md)
 - [SwaggerClient::HosDataDuration](docs/HosDataDuration.md)
 - [SwaggerClient::HosReq](docs/HosReq.md)
 - [SwaggerClient::HosResponse](docs/HosResponse.md)
 - [SwaggerClient::HosResponseSummary](docs/HosResponseSummary.md)
 - [SwaggerClient::InlineResponse200](docs/InlineResponse200.md)
 - [SwaggerClient::InlineResponse200Route](docs/InlineResponse200Route.md)
 - [SwaggerClient::InlineResponse200Summary](docs/InlineResponse200Summary.md)
 - [SwaggerClient::Location](docs/Location.md)
 - [SwaggerClient::PlaceId](docs/PlaceId.md)
 - [SwaggerClient::Rates](docs/Rates.md)
 - [SwaggerClient::Route](docs/Route.md)
 - [SwaggerClient::RouteLocation](docs/RouteLocation.md)
 - [SwaggerClient::RouteResponse](docs/RouteResponse.md)
 - [SwaggerClient::Stop](docs/Stop.md)
 - [SwaggerClient::SyncResponse](docs/SyncResponse.md)
 - [SwaggerClient::SyncResponseRoute](docs/SyncResponseRoute.md)
 - [SwaggerClient::TeritoryMielageRes](docs/TeritoryMielageRes.md)
 - [SwaggerClient::TeritoryMielageResInner](docs/TeritoryMielageResInner.md)
 - [SwaggerClient::TeritoryMielageResInnerTerritory](docs/TeritoryMielageResInnerTerritory.md)
 - [SwaggerClient::Timestamp](docs/Timestamp.md)
 - [SwaggerClient::Toll](docs/Toll.md)
 - [SwaggerClient::Truck](docs/Truck.md)
 - [SwaggerClient::VehicleType](docs/VehicleType.md)


## Documentation for Authorization


### authorizer

- **Type**: API key
- **API key parameter name**: x-api-key
- **Location**: HTTP header

