# SwaggerClient::OriginAndDestinationPairApi

All URIs are relative to *https://dev.tollguru.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**gmaps_post**](OriginAndDestinationPairApi.md#gmaps_post) | **POST** /gmaps | Google Maps Routes
[**here_post**](OriginAndDestinationPairApi.md#here_post) | **POST** /here | HERE Maps Routes


# **gmaps_post**
> GmapResponse gmaps_post(opts)

Google Maps Routes

HTTP Request for cars, SUVs, pick-ups, motorcycles

### Example
```ruby
# load the gem
require 'swagger_client'
# setup authorization
SwaggerClient.configure do |config|
  # Configure API key authorization: authorizer
  config.api_key['x-api-key'] = 'YOUR API KEY'
  # Uncomment the following line to set a prefix for the API key, e.g. 'Bearer' (defaults to nil)
  #config.api_key_prefix['x-api-key'] = 'Bearer'
end

api_instance = SwaggerClient::OriginAndDestinationPairApi.new

opts = { 
  body: SwaggerClient::GmapRequestBody.new # GmapRequestBody | 
}

begin
  #Google Maps Routes
  result = api_instance.gmaps_post(opts)
  p result
rescue SwaggerClient::ApiError => e
  puts "Exception when calling OriginAndDestinationPairApi->gmaps_post: #{e}"
end
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**GmapRequestBody**](GmapRequestBody.md)|  | [optional] 

### Return type

[**GmapResponse**](GmapResponse.md)

### Authorization

[authorizer](../README.md#authorizer)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json



# **here_post**
> HereResponse here_post(opts)

HERE Maps Routes

<p>HTTP Request for trucks, buses, RVs, cars, SUV, pick-ups, motorcycles</p><p>For trucks you should specify truck weight, wherever possible. Some bridges and tunnels restrict trucks based on weight. If you are transporting HAZMAT material, please specify material type. If you do not specify HAZMAT restrictions and weight restrictions, none will be applied.</p>

### Example
```ruby
# load the gem
require 'swagger_client'
# setup authorization
SwaggerClient.configure do |config|
  # Configure API key authorization: authorizer
  config.api_key['x-api-key'] = 'YOUR API KEY'
  # Uncomment the following line to set a prefix for the API key, e.g. 'Bearer' (defaults to nil)
  #config.api_key_prefix['x-api-key'] = 'Bearer'
end

api_instance = SwaggerClient::OriginAndDestinationPairApi.new

opts = { 
  body: SwaggerClient::HereRequestBody.new # HereRequestBody | 
}

begin
  #HERE Maps Routes
  result = api_instance.here_post(opts)
  p result
rescue SwaggerClient::ApiError => e
  puts "Exception when calling OriginAndDestinationPairApi->here_post: #{e}"
end
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**HereRequestBody**](HereRequestBody.md)|  | [optional] 

### Return type

[**HereResponse**](HereResponse.md)

### Authorization

[authorizer](../README.md#authorizer)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json



