=begin
#TollGuru Calculator

#TollGuru Calculator API

OpenAPI spec version: 2020-07-15T09:40:00Z
Contact: eng@tollguru.com
Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.14

=end

require 'uri'

module SwaggerClient
  class GPSTracestracksApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Download Async Results
    # The results will be available for download for upto 30 days by calling the API.
    # @param [Hash] opts the optional parameters
    # @option opts [Body1] :body 
    # @return [SyncResponse]
    def route_download_post(opts = {})
      data, _status_code, _headers = route_download_post_with_http_info(opts)
      data
    end

    # Download Async Results
    # The results will be available for download for upto 30 days by calling the API.
    # @param [Hash] opts the optional parameters
    # @option opts [Body1] :body 
    # @return [Array<(SyncResponse, Fixnum, Hash)>] SyncResponse data, response status code and response headers
    def route_download_post_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: GPSTracestracksApi.route_download_post ...'
      end
      # resource path
      local_var_path = '/route/download'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(opts[:'body'])
      auth_names = []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'SyncResponse')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: GPSTracestracksApi#route_download_post\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Request
    # <p>This API can be used in synchronous and asynchronous modes. The default mode of operation is synchronous mode where the API response with toll information is returned immediately.</p><p>Asynchronous mode is used in the following cases: </p><ul> <li>Bulk upload of multiple GPS tracks files</li><li>Uploading large GPS tracks files</li></ul><p>In asynchronous mode, the response is returned immediately with a <code>requestId</code> and <code>requestedTimestamp</code>. The results will be available for download for upto 30 days by calling the <code>route/download</code> API. Asynchronous mode can used by specifying the url parameter <code>isAsync=true</code>.</p><p>GPS traces can be passed in the following format </p><ul> <li>Upload CSV file</li><li>Upload kml file</li></ul><p>The first line in the CSV needs to contain the attribute names. The subsequent lines needs to contain the data in temporal order. The following parameters are available:</p><table><thead><tr><th>Parameter</th><th>Description</th></tr></thead><tbody><tr><td><strong>latitude</strong></td><td>Latitude coordinate in WGS84 degree (mandatory)</td></tr><tr><td><strong>longitude</strong></td><td>Longitude coordinate in WGS84 degree (mandatory)</td></tr><tr><td><strong>timestamp</strong></td><td>indicates the time and date, for example&nbsp;&nbsp;2018-05-21T17:05:06Z (mandatory since tolls may change based on time)</td></tr><tr><td><strong>speed_mps</strong></td><td>speed in meters per second (optional)</td></tr><tr><td><strong>speed_mph</strong></td><td>speed in miles per hour (optional)</td></tr><tr><td><strong>speed_kmh</strong></td><td>speed in kilometers per hour (optional)</td></tr><tr><td><strong>heading</strong></td><td>heading in degrees clockwise from North (optional)</td></tr></tbody></table><p>You can download sample file from <a href=\"https://tollguru-cdn.s3.us-east-2.amazonaws.com/trip_route.csv\" target=\"_blank\">here</a></p><p>Or use the CSV format file as shown in the table below:</p><table> <tr> <th>latitude</th> <th>longitude</th> <th>timestamp</th> </tr><tr> <td style=\"text-align: center;\">38.90479</td><td style=\"text-align: center;\">-77.02607</td><td style=\"text-align: center;\">2019-12-16T15:45:23Z</td></tr><tr> <td style=\"text-align: center;\">38.90479</td><td style=\"text-align: center;\">-77.02606</td><td style=\"text-align: center;\">2019-12-16T15:47:24Z</td></tr><tr> <td style=\"text-align: center;\">38.9048</td><td style=\"text-align: center;\">-77.02608</td><td style=\"text-align: center;\">2019-12-16T15:49:25Z</td></tr><tr> <td style=\"text-align: center;\">38.9044</td><td style=\"text-align: center;\">-77.02604</td><td style=\"text-align: center;\">2019-12-16T15:50:42Z</td></tr><tr> <td style=\"text-align: center;\">38.90424</td><td style=\"text-align: center;\">-77.02646</td><td style=\"text-align: center;\">2019-12-16T15:50:49Z</td></tr><tr> <td style=\"text-align: center;\">38.90422</td><td style=\"text-align: center;\">-77.02686</td><td style=\"text-align: center;\">2019-12-16T15:50:55Z</td></tr></table>
    # @param vehicle_type 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :vehicle_name Specify name for your vehicle to identify the response json for particular vehicle
    # @option opts [String] :height Specify the vehicle height to get accurate tolls for toll roads where tolls depend on axles and vehicle height
    # @option opts [String] :weight Specify the vehicle weight to get accurate tolls for toll roads where tolls depend on axles and vehicle weight
    # @option opts [BOOLEAN] :is_async The API will function in asynchronous mode is set to true (default to false)
    # @option opts [String] :body 
    # @return [Object]
    def route_upload_post(vehicle_type, opts = {})
      data, _status_code, _headers = route_upload_post_with_http_info(vehicle_type, opts)
      data
    end

    # Request
    # &lt;p&gt;This API can be used in synchronous and asynchronous modes. The default mode of operation is synchronous mode where the API response with toll information is returned immediately.&lt;/p&gt;&lt;p&gt;Asynchronous mode is used in the following cases: &lt;/p&gt;&lt;ul&gt; &lt;li&gt;Bulk upload of multiple GPS tracks files&lt;/li&gt;&lt;li&gt;Uploading large GPS tracks files&lt;/li&gt;&lt;/ul&gt;&lt;p&gt;In asynchronous mode, the response is returned immediately with a &lt;code&gt;requestId&lt;/code&gt; and &lt;code&gt;requestedTimestamp&lt;/code&gt;. The results will be available for download for upto 30 days by calling the &lt;code&gt;route/download&lt;/code&gt; API. Asynchronous mode can used by specifying the url parameter &lt;code&gt;isAsync&#x3D;true&lt;/code&gt;.&lt;/p&gt;&lt;p&gt;GPS traces can be passed in the following format &lt;/p&gt;&lt;ul&gt; &lt;li&gt;Upload CSV file&lt;/li&gt;&lt;li&gt;Upload kml file&lt;/li&gt;&lt;/ul&gt;&lt;p&gt;The first line in the CSV needs to contain the attribute names. The subsequent lines needs to contain the data in temporal order. The following parameters are available:&lt;/p&gt;&lt;table&gt;&lt;thead&gt;&lt;tr&gt;&lt;th&gt;Parameter&lt;/th&gt;&lt;th&gt;Description&lt;/th&gt;&lt;/tr&gt;&lt;/thead&gt;&lt;tbody&gt;&lt;tr&gt;&lt;td&gt;&lt;strong&gt;latitude&lt;/strong&gt;&lt;/td&gt;&lt;td&gt;Latitude coordinate in WGS84 degree (mandatory)&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;strong&gt;longitude&lt;/strong&gt;&lt;/td&gt;&lt;td&gt;Longitude coordinate in WGS84 degree (mandatory)&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;strong&gt;timestamp&lt;/strong&gt;&lt;/td&gt;&lt;td&gt;indicates the time and date, for example&amp;nbsp;&amp;nbsp;2018-05-21T17:05:06Z (mandatory since tolls may change based on time)&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;strong&gt;speed_mps&lt;/strong&gt;&lt;/td&gt;&lt;td&gt;speed in meters per second (optional)&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;strong&gt;speed_mph&lt;/strong&gt;&lt;/td&gt;&lt;td&gt;speed in miles per hour (optional)&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;strong&gt;speed_kmh&lt;/strong&gt;&lt;/td&gt;&lt;td&gt;speed in kilometers per hour (optional)&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;strong&gt;heading&lt;/strong&gt;&lt;/td&gt;&lt;td&gt;heading in degrees clockwise from North (optional)&lt;/td&gt;&lt;/tr&gt;&lt;/tbody&gt;&lt;/table&gt;&lt;p&gt;You can download sample file from &lt;a href&#x3D;\&quot;https://tollguru-cdn.s3.us-east-2.amazonaws.com/trip_route.csv\&quot; target&#x3D;\&quot;_blank\&quot;&gt;here&lt;/a&gt;&lt;/p&gt;&lt;p&gt;Or use the CSV format file as shown in the table below:&lt;/p&gt;&lt;table&gt; &lt;tr&gt; &lt;th&gt;latitude&lt;/th&gt; &lt;th&gt;longitude&lt;/th&gt; &lt;th&gt;timestamp&lt;/th&gt; &lt;/tr&gt;&lt;tr&gt; &lt;td style&#x3D;\&quot;text-align: center;\&quot;&gt;38.90479&lt;/td&gt;&lt;td style&#x3D;\&quot;text-align: center;\&quot;&gt;-77.02607&lt;/td&gt;&lt;td style&#x3D;\&quot;text-align: center;\&quot;&gt;2019-12-16T15:45:23Z&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt; &lt;td style&#x3D;\&quot;text-align: center;\&quot;&gt;38.90479&lt;/td&gt;&lt;td style&#x3D;\&quot;text-align: center;\&quot;&gt;-77.02606&lt;/td&gt;&lt;td style&#x3D;\&quot;text-align: center;\&quot;&gt;2019-12-16T15:47:24Z&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt; &lt;td style&#x3D;\&quot;text-align: center;\&quot;&gt;38.9048&lt;/td&gt;&lt;td style&#x3D;\&quot;text-align: center;\&quot;&gt;-77.02608&lt;/td&gt;&lt;td style&#x3D;\&quot;text-align: center;\&quot;&gt;2019-12-16T15:49:25Z&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt; &lt;td style&#x3D;\&quot;text-align: center;\&quot;&gt;38.9044&lt;/td&gt;&lt;td style&#x3D;\&quot;text-align: center;\&quot;&gt;-77.02604&lt;/td&gt;&lt;td style&#x3D;\&quot;text-align: center;\&quot;&gt;2019-12-16T15:50:42Z&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt; &lt;td style&#x3D;\&quot;text-align: center;\&quot;&gt;38.90424&lt;/td&gt;&lt;td style&#x3D;\&quot;text-align: center;\&quot;&gt;-77.02646&lt;/td&gt;&lt;td style&#x3D;\&quot;text-align: center;\&quot;&gt;2019-12-16T15:50:49Z&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt; &lt;td style&#x3D;\&quot;text-align: center;\&quot;&gt;38.90422&lt;/td&gt;&lt;td style&#x3D;\&quot;text-align: center;\&quot;&gt;-77.02686&lt;/td&gt;&lt;td style&#x3D;\&quot;text-align: center;\&quot;&gt;2019-12-16T15:50:55Z&lt;/td&gt;&lt;/tr&gt;&lt;/table&gt;
    # @param vehicle_type 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :vehicle_name Specify name for your vehicle to identify the response json for particular vehicle
    # @option opts [String] :height Specify the vehicle height to get accurate tolls for toll roads where tolls depend on axles and vehicle height
    # @option opts [String] :weight Specify the vehicle weight to get accurate tolls for toll roads where tolls depend on axles and vehicle weight
    # @option opts [BOOLEAN] :is_async The API will function in asynchronous mode is set to true
    # @option opts [String] :body 
    # @return [Array<(Object, Fixnum, Hash)>] Object data, response status code and response headers
    def route_upload_post_with_http_info(vehicle_type, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: GPSTracestracksApi.route_upload_post ...'
      end
      # verify the required parameter 'vehicle_type' is set
      if @api_client.config.client_side_validation && vehicle_type.nil?
        fail ArgumentError, "Missing the required parameter 'vehicle_type' when calling GPSTracestracksApi.route_upload_post"
      end
      # verify enum value
      if @api_client.config.client_side_validation && !['2AxlesAuto', '3AxlesAuto', '4AxlesAuto', '2AxlesDualTire', '3AxlesDualTire', '4AxlesDualTire', '2AxlesTruck', '3AxlesTruck', '4AxlesTruck', '5AxlesTruck', '6AxlesTruck', '7AxlesTruck', '8AxlesTruck', '9AxlesTruck', '2AxlesBus', '3AxlesBus', '2AxlesMotorcycle', '3AxlesMotorcycle', '2AxlesRv', '3AxlesRv', '4AxlesRv'].include?(vehicle_type)
        fail ArgumentError, "invalid value for 'vehicle_type', must be one of 2AxlesAuto, 3AxlesAuto, 4AxlesAuto, 2AxlesDualTire, 3AxlesDualTire, 4AxlesDualTire, 2AxlesTruck, 3AxlesTruck, 4AxlesTruck, 5AxlesTruck, 6AxlesTruck, 7AxlesTruck, 8AxlesTruck, 9AxlesTruck, 2AxlesBus, 3AxlesBus, 2AxlesMotorcycle, 3AxlesMotorcycle, 2AxlesRv, 3AxlesRv, 4AxlesRv"
      end
      # resource path
      local_var_path = '/route/upload'

      # query parameters
      query_params = {}
      query_params[:'vehicleType'] = vehicle_type
      query_params[:'vehicleName'] = opts[:'vehicle_name'] if !opts[:'vehicle_name'].nil?
      query_params[:'height'] = opts[:'height'] if !opts[:'height'].nil?
      query_params[:'weight'] = opts[:'weight'] if !opts[:'weight'].nil?
      query_params[:'isAsync'] = opts[:'is_async'] if !opts[:'is_async'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['text/csv'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(opts[:'body'])
      auth_names = []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Object')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: GPSTracestracksApi#route_upload_post\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
