=begin
#TollGuru Calculator

#TollGuru Calculator API

OpenAPI spec version: 2020-07-15T09:40:00Z
Contact: eng@tollguru.com
Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.14

=end

require 'date'

module SwaggerClient
  class HereRequestBody
    attr_accessor :departure_time

    # Driver wage or Value of Time
    attr_accessor :driver

    attr_accessor :from

    attr_accessor :fuel_efficiency

    attr_accessor :fuel_price

    attr_accessor :fuel_price_currency

    attr_accessor :hos

    attr_accessor :state_mileage

    attr_accessor :to

    # Truck routing only
    attr_accessor :truck

    attr_accessor :vehicle_type

    attr_accessor :waypoints

    class EnumAttributeValidator
      attr_reader :datatype
      attr_reader :allowable_values

      def initialize(datatype, allowable_values)
        @allowable_values = allowable_values.map do |value|
          case datatype.to_s
          when /Integer/i
            value.to_i
          when /Float/i
            value.to_f
          else
            value
          end
        end
      end

      def valid?(value)
        !value || allowable_values.include?(value)
      end
    end

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'departure_time' => :'departure_time',
        :'driver' => :'driver',
        :'from' => :'from',
        :'fuel_efficiency' => :'fuelEfficiency',
        :'fuel_price' => :'fuelPrice',
        :'fuel_price_currency' => :'fuelPriceCurrency',
        :'hos' => :'hos',
        :'state_mileage' => :'state_mileage',
        :'to' => :'to',
        :'truck' => :'truck',
        :'vehicle_type' => :'vehicleType',
        :'waypoints' => :'waypoints'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'departure_time' => :'Object',
        :'driver' => :'Object',
        :'from' => :'Object',
        :'fuel_efficiency' => :'Object',
        :'fuel_price' => :'Float',
        :'fuel_price_currency' => :'String',
        :'hos' => :'Object',
        :'state_mileage' => :'BOOLEAN',
        :'to' => :'Object',
        :'truck' => :'Object',
        :'vehicle_type' => :'Object',
        :'waypoints' => :'Array<Location>'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      if attributes.has_key?(:'departure_time')
        self.departure_time = attributes[:'departure_time']
      end

      if attributes.has_key?(:'driver')
        self.driver = attributes[:'driver']
      end

      if attributes.has_key?(:'from')
        self.from = attributes[:'from']
      end

      if attributes.has_key?(:'fuelEfficiency')
        self.fuel_efficiency = attributes[:'fuelEfficiency']
      end

      if attributes.has_key?(:'fuelPrice')
        self.fuel_price = attributes[:'fuelPrice']
      end

      if attributes.has_key?(:'fuelPriceCurrency')
        self.fuel_price_currency = attributes[:'fuelPriceCurrency']
      else
        self.fuel_price_currency = 'USD'
      end

      if attributes.has_key?(:'hos')
        self.hos = attributes[:'hos']
      end

      if attributes.has_key?(:'state_mileage')
        self.state_mileage = attributes[:'state_mileage']
      end

      if attributes.has_key?(:'to')
        self.to = attributes[:'to']
      end

      if attributes.has_key?(:'truck')
        self.truck = attributes[:'truck']
      end

      if attributes.has_key?(:'vehicleType')
        self.vehicle_type = attributes[:'vehicleType']
      end

      if attributes.has_key?(:'waypoints')
        if (value = attributes[:'waypoints']).is_a?(Array)
          self.waypoints = value
        end
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if @from.nil?
        invalid_properties.push('invalid value for "from", from cannot be nil.')
      end

      if @to.nil?
        invalid_properties.push('invalid value for "to", to cannot be nil.')
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if @from.nil?
      fuel_price_currency_validator = EnumAttributeValidator.new('String', ['USD', 'CAD', 'MXN', 'INR'])
      return false unless fuel_price_currency_validator.valid?(@fuel_price_currency)
      return false if @to.nil?
      true
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] fuel_price_currency Object to be assigned
    def fuel_price_currency=(fuel_price_currency)
      validator = EnumAttributeValidator.new('String', ['USD', 'CAD', 'MXN', 'INR'])
      unless validator.valid?(fuel_price_currency)
        fail ArgumentError, 'invalid value for "fuel_price_currency", must be one of #{validator.allowable_values}.'
      end
      @fuel_price_currency = fuel_price_currency
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          departure_time == o.departure_time &&
          driver == o.driver &&
          from == o.from &&
          fuel_efficiency == o.fuel_efficiency &&
          fuel_price == o.fuel_price &&
          fuel_price_currency == o.fuel_price_currency &&
          hos == o.hos &&
          state_mileage == o.state_mileage &&
          to == o.to &&
          truck == o.truck &&
          vehicle_type == o.vehicle_type &&
          waypoints == o.waypoints
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [departure_time, driver, from, fuel_efficiency, fuel_price, fuel_price_currency, hos, state_mileage, to, truck, vehicle_type, waypoints].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = SwaggerClient.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end
end
