=begin
#TollGuru Calculator

#TollGuru Calculator API

OpenAPI spec version: 2020-07-15T09:40:00Z
Contact: eng@tollguru.com
Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.14

=end

require 'date'

module SwaggerClient
  # Tolls object contains tolls for all the toll locations on the route. For each toll location
  class Toll
    # Cash toll cost
    attr_accessor :cash_cost

    # Credit card toll cost
    attr_accessor :credit_card_cost

    # Currency
    attr_accessor :currency

    # Tollguru toll ID. Useful for error checking
    attr_accessor :id

    # Approximate latitude of the toll location
    attr_accessor :lat

    # License plate (video) toll cost. For example, <a href=\"https://tollguru.com/toll-info/california/pay-by-plate-payment\" target=\"_blank\">Pay by Plate</a> in California, <a href=\"https://tollguru.com/toll-info/texas/pay-by-mail\" target=\"_blank\">ZipCash and Pay by Mail</a> in Texas, <a href=\"https://tollguru.com/toll-info/florida/video-payment\" target=\"_blank\">Pay by Plate</a> in Florida, <a href=\"https://tollguru.com/toll-info/colorado/video-payment\" target=\"_blank\">License Plate Toll</a> in Colorado, Camera Charges on ETR-407, etc.
    attr_accessor :license_plate_cost

    # Name of the primary license plate toll (video toll) collection system. Typically license Plate tolls are not discounted.
    attr_accessor :license_plate_primary

    # Name of the secondary license plate toll (video toll) collection system
    attr_accessor :license_plate_secondary

    # Approximate longitude of the toll location
    attr_accessor :lng

    # Name of the toll location
    attr_accessor :name

    # Prepaid card such as Nexpress, Nexus Card, etc. toll cost
    attr_accessor :prepaid_card_cost

    # Name of the toll road
    attr_accessor :road

    # State, province of the toll location
    attr_accessor :state

    # Transponder toll cost <br>For example, <a href=\"https://tollguru.com/toll-info/new-york/what-is-e-zpass\" target=\"_blank\">E-ZPass</a>, <a href=\"https://tollguru.com/toll-info/texas/what-is-txtag-tolltag-eztag\" target=\"_blank\">TxTag</a>, <a href=\"https://tollguru.com/toll-info/california/what-is-fastrak\" target=\"_blank\">FasTrak</a>, <a href=\"https://tollguru.com/toll-info/florida/what-is-sunpass\" target=\"_blank\">SunPass</a>, <a href=\"https://tollguru.com/toll-info/california/what-is-fastrak\" target=\"_blank\">FasTrak</a>, <a href=\"https://tollguru.com/toll-info/colorado/what-is-expresstoll-go-pass\" target=\"_blank\">ExpressToll</a>, etc.
    attr_accessor :tag_cost

    # A primary transponder that can be used on the facility. Typically primary transponders have discounts for each usage or based on volume.
    attr_accessor :tag_primary

    # All other transponders that can be used on the facility. Secondary transponders may not count towards discounts
    attr_accessor :tag_secondary

    # Toll type: <br><code>barrier</code> (for example <a href=\"https://tollguru.com/toll-info/texas/texas-toll-roads-bridges-express-lanes\" target=\"_blank\"> toll roads in Texas </a>), <br><code>ticketSystem</code> - ticket system (for example <a href=\"https://tollguru.com/toll-info/oklahoma/oklahoma-turnpikes\" target=\"_blank\"> toll roads in Oklahoma</a>), <br><code>distBased</code> – distance based (for example <a href=\"https://tollguru.com/toll-info/ontario/ontario-407-ETR-toll-highway-bridges-tunnels\" target=\"_blank\"> ETR 407 in Ontario, Canada</a>).
    attr_accessor :type

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'cash_cost' => :'cashCost',
        :'credit_card_cost' => :'creditCardCost',
        :'currency' => :'currency',
        :'id' => :'id',
        :'lat' => :'lat',
        :'license_plate_cost' => :'licensePlateCost',
        :'license_plate_primary' => :'licensePlatePrimary',
        :'license_plate_secondary' => :'licensePlateSecondary',
        :'lng' => :'lng',
        :'name' => :'name',
        :'prepaid_card_cost' => :'prepaidCardCost',
        :'road' => :'road',
        :'state' => :'state',
        :'tag_cost' => :'tagCost',
        :'tag_primary' => :'tagPrimary',
        :'tag_secondary' => :'tagSecondary',
        :'type' => :'type'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'cash_cost' => :'Float',
        :'credit_card_cost' => :'Float',
        :'currency' => :'String',
        :'id' => :'Float',
        :'lat' => :'Float',
        :'license_plate_cost' => :'Float',
        :'license_plate_primary' => :'String',
        :'license_plate_secondary' => :'String',
        :'lng' => :'Float',
        :'name' => :'String',
        :'prepaid_card_cost' => :'Float',
        :'road' => :'String',
        :'state' => :'String',
        :'tag_cost' => :'Float',
        :'tag_primary' => :'Array<String>',
        :'tag_secondary' => :'Array<String>',
        :'type' => :'String'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      if attributes.has_key?(:'cashCost')
        self.cash_cost = attributes[:'cashCost']
      end

      if attributes.has_key?(:'creditCardCost')
        self.credit_card_cost = attributes[:'creditCardCost']
      end

      if attributes.has_key?(:'currency')
        self.currency = attributes[:'currency']
      end

      if attributes.has_key?(:'id')
        self.id = attributes[:'id']
      end

      if attributes.has_key?(:'lat')
        self.lat = attributes[:'lat']
      end

      if attributes.has_key?(:'licensePlateCost')
        self.license_plate_cost = attributes[:'licensePlateCost']
      end

      if attributes.has_key?(:'licensePlatePrimary')
        self.license_plate_primary = attributes[:'licensePlatePrimary']
      end

      if attributes.has_key?(:'licensePlateSecondary')
        self.license_plate_secondary = attributes[:'licensePlateSecondary']
      end

      if attributes.has_key?(:'lng')
        self.lng = attributes[:'lng']
      end

      if attributes.has_key?(:'name')
        self.name = attributes[:'name']
      end

      if attributes.has_key?(:'prepaidCardCost')
        self.prepaid_card_cost = attributes[:'prepaidCardCost']
      end

      if attributes.has_key?(:'road')
        self.road = attributes[:'road']
      end

      if attributes.has_key?(:'state')
        self.state = attributes[:'state']
      end

      if attributes.has_key?(:'tagCost')
        self.tag_cost = attributes[:'tagCost']
      end

      if attributes.has_key?(:'tagPrimary')
        if (value = attributes[:'tagPrimary']).is_a?(Array)
          self.tag_primary = value
        end
      end

      if attributes.has_key?(:'tagSecondary')
        if (value = attributes[:'tagSecondary']).is_a?(Array)
          self.tag_secondary = value
        end
      end

      if attributes.has_key?(:'type')
        self.type = attributes[:'type']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      true
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          cash_cost == o.cash_cost &&
          credit_card_cost == o.credit_card_cost &&
          currency == o.currency &&
          id == o.id &&
          lat == o.lat &&
          license_plate_cost == o.license_plate_cost &&
          license_plate_primary == o.license_plate_primary &&
          license_plate_secondary == o.license_plate_secondary &&
          lng == o.lng &&
          name == o.name &&
          prepaid_card_cost == o.prepaid_card_cost &&
          road == o.road &&
          state == o.state &&
          tag_cost == o.tag_cost &&
          tag_primary == o.tag_primary &&
          tag_secondary == o.tag_secondary &&
          type == o.type
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [cash_cost, credit_card_cost, currency, id, lat, license_plate_cost, license_plate_primary, license_plate_secondary, lng, name, prepaid_card_cost, road, state, tag_cost, tag_primary, tag_secondary, type].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = SwaggerClient.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end
end
